//=============================================================================
// CfgLanS.c
// ணࠬ 䨣஢ LanScan
//=============================================================================
#define INCL_WIN

#include <os2.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <netdb.h>
#include <types.h>
#include <sys/socket.h>
#include <sys\ioctl.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <net\if.h>
#ifndef TCPV40HDRS   // ᪫  TCP/IP 4.0
#include <arpa/inet.h>
#include <unistd.h>
#endif               // TCPV40HDRS
#include <nerrno.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <libc\sys\stat.h>
#include "LanScan.h"

//-----------------------------------------------------------------------------
// Dialog Window procedure prototype
//-----------------------------------------------------------------------------
MRESULT EXPENTRY DlgMenu (HWND, ULONG ,MPARAM, MPARAM);
void SendErrMsg(HWND, char *);
struct sockaddr_in resolv(HWND, char *);
MRESULT EXPENTRY DlgProcPING (HWND, ULONG, MPARAM, MPARAM); // Dlg proc (PING)
MRESULT EXPENTRY DlgProcOPT  (HWND, ULONG, MPARAM, MPARAM); // Dlg proc (OPT)
MRESULT EXPENTRY DlgProcARP  (HWND, ULONG, MPARAM, MPARAM); // Dlg proc (ARP)
MRESULT EXPENTRY DlgProcRead (HWND, ULONG, MPARAM, MPARAM); // Dlg proc (Read)
MRESULT EXPENTRY DlgProcWrite (HWND, ULONG, MPARAM, MPARAM); // Dlg proc (Write)
BOOL TestPing(char *);
void SendWngMsg(HWND, char *);
BOOL GetFileName(char *, char *);
BOOL TestInt(char *, int);
void SaveOpt (char *);
void GetOpt (char *);
void GetFileCfg(HWND, char *);
void PutFileCfg(HWND, char *);

//-----------------------------------------------------------------------------
// Global Variablies
//-----------------------------------------------------------------------------
int ac;
char **av;
struct sockaddr_in myaddr = { 0 };
char CFGname[] = "LANSCAN.CFR";

//=============================================================================
// Main procedure
//=============================================================================
void main(int argc, char *argv[])
     {
     HAB   hab = WinInitialize (0);          // Anchor
     HMQ   hmq = WinCreateMsgQueue(hab, 0);  // Message queue handle

     ac = argc;
     av = argv;

#ifdef TCPV40HDRS    //   TCP/IP 4.0
     sock_init();
#endif               // TCPV40HDRS

     WinDlgBox( HWND_DESKTOP,
                HWND_DESKTOP,
                DlgMenu,
                NULLHANDLE,
                DIALOGWIN,
                0 );

     WinDestroyMsgQueue(hmq);
     WinTerminate(hab);
     }

//=============================================================================
// Dialog procedure
//=============================================================================
MRESULT EXPENTRY DlgMenu (HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
  {
  int i;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Handle the initialization of the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      unsigned short port;
      char TextIP[16], TextPort[6];
//-----------------------------------------------------------------------------
// Set icon & menu
//-----------------------------------------------------------------------------
      HPOINTER hptr = (HPOINTER)WinLoadPointer(HWND_DESKTOP, NULLHANDLE, 1);
      WinSendMsg(hwndDlg, WM_SETICON, (MPARAM) hptr, 0l);

      WinLoadMenu(hwndDlg, NULLHANDLE, MENU_ID);
      WinSendMsg(hwndDlg, WM_UPDATEFRAME, (MPARAM) FCF_MENU, 0l);

      if ( ac != 3 )
        {
        SendErrMsg(hwndDlg, "Syntax: CfgLanS <IP address> port");
        break;
        }

      myaddr = resolv(hwndDlg, av[1]);
      sprintf(TextIP, "%s", inet_ntoa(myaddr.sin_addr));
      WinSetDlgItemText(hwndDlg, TXT_IP, TextIP);

      port = (unsigned short)atoi(av[2]);
      sprintf(TextPort, "%d", port);
      WinSetDlgItemText(hwndDlg, TXT_PORT, TextPort);

      myaddr.sin_family = AF_INET;
      myaddr.sin_port = htons(port);

      GetOpt(CFGname);   // Get Options

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
//-----------------------------------------------------------------------------
// Close the dialog
//-----------------------------------------------------------------------------
        case ITEM_EXIT:
          {
          WinSendMsg(hwndDlg, WM_CLOSE, 0L, 0L);
          break;
          }
//-----------------------------------------------------------------------------
// Read
//-----------------------------------------------------------------------------
        case ITEM_READ:
          {
          WinDlgBox (HWND_DESKTOP, // Parent
                     hwndDlg,      // Owner
                     DlgProcRead,  // Dialog window procedure
                     NULLHANDLE,   // Where is dialog resource?
                     DIALOGREADPW, // Dialog Resource ID
                     0);       // Create parms (for WM_INITDLG)
          return(MRFROMSHORT(TRUE));
          }
//-----------------------------------------------------------------------------
// Write
//-----------------------------------------------------------------------------
        case ITEM_WRITE:
          {
          WinDlgBox (HWND_DESKTOP, // Parent
                     hwndDlg,      // Owner
                     DlgProcWrite, // Dialog window procedure
                     NULLHANDLE,   // Where is dialog resource?
                     DIALOGWRITEPW, // Dialog Resource ID
                     0);       // Create parms (for WM_INITDLG)
          return(MRFROMSHORT(TRUE));
          }
//-----------------------------------------------------------------------------
// ARP
//-----------------------------------------------------------------------------
        case ITEM_ARP:
          {
          WinDlgBox (HWND_DESKTOP, // Parent
                     hwndDlg,      // Owner
                     DlgProcARP,   // Dialog window procedure
                     NULLHANDLE,   // Where is dialog resource?
                     ARP_ID,       // Dialog Resource ID
                     0);       // Create parms (for WM_INITDLG)

          return(MRFROMSHORT(TRUE));
          }
//-----------------------------------------------------------------------------
// PING
//-----------------------------------------------------------------------------
        case ITEM_PING:
          {
          WinDlgBox (HWND_DESKTOP, // Parent
                     hwndDlg,      // Owner
                     DlgProcPING,  // Dialog window procedure
                     NULLHANDLE,   // Where is dialog resource?
                     PING_ID,      // Dialog Resource ID
                     0);           // Create parms (for WM_INITDLG)

          return(MRFROMSHORT(TRUE));
          }
//-----------------------------------------------------------------------------
// Options
//-----------------------------------------------------------------------------
        case ITEM_OPTIONS:
          {
          WinDlgBox (HWND_DESKTOP, // Parent
                     hwndDlg,      // Owner
                     DlgProcOPT,  // Dialog window procedure
                     NULLHANDLE,   // Where is dialog resource?
                     OPTIONS_ID,      // Dialog Resource ID
                     0);       // Creatin parms (for WM_INITDLG)

          return(MRFROMSHORT(TRUE));
          }

        }
      break;
      }
    }

  return WinDefDlgProc(hwndDlg, msg, mp1, mp2);
  }

//=============================================================================
// GetFileCfg - ணࠬ 祭 䠩 䨣樨
//=============================================================================
void GetFileCfg(HWND hwnd, char *passw)
{
int sock, len, i;
char buf[MAXINILEN];
FILE *File;
fd_set r;
struct timeval mytimeout;
char *p, RecvBuf[L513];

  mytimeout.tv_sec = L3;  //  3 ᥪ㭤
  mytimeout.tv_usec = L0;

  sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

// Connect to the server.
  if ( connect(sock, (struct sockaddr *)&myaddr, sizeof(myaddr)) < 0 )
    {
    SendWngMsg(hwnd, "Error in connect");
    soclose(sock);
    return;
    }

  strcpy(buf, "Get");
  strcat(buf, passw);

  send(sock, buf, PWDLEN+L4, L0);

  FD_ZERO(&r);
  FD_SET(sock, &r);

  if ( select(sock+1, &r, NULL, NULL, &mytimeout) <= 0 )
    {
    SendWngMsg(hwnd, "Error in select");
    soclose(sock);
    return;
    }

//  Receive the configuration
  for ( len=0, p=buf;; )
    {
    i = recv(sock, RecvBuf, sizeof(RecvBuf), L0);
    if ( i == 0 )
      {
      SendWngMsg(hwnd, "Error in recv");
      soclose(sock);
      return;
      }

    memcpy(p, RecvBuf+1, i-1);
    len = len+i-1;
    if ( RecvBuf[0] != 0 ) p += L512;
    else break;
    }

  soclose(sock);

  File = fopen(CFGname, "wb");
  fwrite(buf, len, L1, File);
  fclose(File);

  GetOpt(CFGname);   // Get Options
}

//=============================================================================
// PutFileCfg - ணࠬ ࠢ 䠩 䨣樨
//=============================================================================
void PutFileCfg(HWND hwnd, char *passw)
{
int sock, len, SendLen, i;
char buf[MAXINILEN], *p, SendBuf[L513];
FILE *File;
struct stat info;

  SaveOpt(CFGname);
  stat(CFGname, &info);
  if ( (int)info.st_size > MAXINILEN )
    {
    SendWngMsg(hwnd, "INI file is too big");
    return;
    }

  memset(buf, '\0', PWDLEN+L4);
  strcpy(buf, "Put");
  strcat(buf, passw);

  sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

// Connect to the server.
  if ( connect(sock, (struct sockaddr *)&myaddr, sizeof(myaddr)) < 0 )
    {
    SendWngMsg(hwnd, "Error in connect");
    soclose(sock);
    return;
    }

  send(sock, buf, PWDLEN+L4, L0);
  File = fopen(CFGname, "rb");
  fread(buf, (int)info.st_size, L1, File);
  fclose(File);

// Send the Configuration to Client.
  for ( SendLen=(int)info.st_size, p=buf; SendLen>0; )
    {
    if ( SendLen > L512 )
      {
      SendBuf[0] = L1;  //  ᫥ 
      memcpy(SendBuf+1, p, L512);
      p += L512;
      SendLen -= L512;
      i = L513;
      }
    else
      {
      SendBuf[0] = L0;  // ᫥ 
      memcpy(SendBuf+L1, p, SendLen);
      i = SendLen+L1;
      SendLen = 0;
      }
    send(sock, SendBuf, i, L0);
    }
  soclose(sock);
}

//=============================================================================
// DlgProcRead - window procedure for the Read passowrd
//=============================================================================
MRESULT EXPENTRY DlgProcRead (HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
char passw[PWDLEN];

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      WinSendDlgItemMsg(hwndDlg, READ_PW, EM_SETTEXTLIMIT, (MPARAM)L15, 0);
      memset(passw, '\0', PWDLEN);
      WinSetDlgItemText(hwndDlg, READ_PW, passw);
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          WinQueryDlgItemText(hwndDlg, READ_PW, PWDLEN, passw);
          GetFileCfg(hwndDlg, passw);
          break;
          }
        }
      }
      break;
    }
    return (WinDefDlgProc (hwndDlg,msg,mp1,mp2));
}

//=============================================================================
// DlgProcWrite - window procedure for the Write passowrd
//=============================================================================
MRESULT EXPENTRY DlgProcWrite (HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
char passw[PWDLEN];

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      WinSendDlgItemMsg(hwndDlg, WRITE_PW, EM_SETTEXTLIMIT, (MPARAM)L15, 0);
      memset(passw, '\0', PWDLEN);
      WinSetDlgItemText(hwndDlg, WRITE_PW, passw);
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          WinQueryDlgItemText(hwndDlg, WRITE_PW, PWDLEN, passw);
          PutFileCfg(hwndDlg, passw);
          break;
          }
        }
      }
      break;
    }
    return (WinDefDlgProc (hwndDlg,msg,mp1,mp2));
}

#include "SubPgm\DlgProcARP.c"
#include "SubPgm\DlgProcOPT.c"
#include "SubPgm\DlgProcPING.c"
#include "SubPgm\GetFileName.c"
#include "SubPgm\GetOpt.c"
#include "SubPgm\resolv.c"
#include "SubPgm\SaveOpt.c"
#include "SubPgm\SendErrMsg.c"
#include "SubPgm\SendWngMsg.c"
#include "SubPgm\TestInt.c"
#include "SubPgm\TestPing.c"