//=============================================================================
// DlgProcOPT - window procedure for the Options dialog
//=============================================================================
MRESULT EXPENTRY DlgProcOPT (HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
int i;
static char mAutoRun, mAutoLog, mCommonLog, museDNS;
static char mAutoSave, museOTHD, mCrtHTMLfile;
static unsigned int mInterval, mArpWait, mTcpWait;
static long mtv_sec;
static CHAR mszFullPath[CCHMAXPATH];
static CHAR mHTMLpath[CCHMAXPATH];
short swt;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      mAutoRun = AutoRun;
      mAutoLog = AutoLog;
      mCommonLog = CommonLog;
      mInterval = Interval;
      museDNS = useDNS;
      museOTHD = useOTHD;
      mtv_sec = pingtv.tv_sec;
      mArpWait = ArpWait;
      mTcpWait = TcpWait;
      mCrtHTMLfile = CrtHTMLfile;
      mAutoSave = AutoSave;
      strcpy(mszFullPath, szFullPath);
      strcpy(mHTMLpath, HTMLpath);

      for ( i=TO_PING_01; i<=TO_PING_10; i++ )
        if ( TO_PING_01+mtv_sec-1 != i ) WinCheckButton(hwndDlg, i, FALSE);
        else WinCheckButton(hwndDlg, i, TRUE);

      for ( i=ARUN_05; i<=ARUN_60; i++ )
        if ( ARUN_05+mInterval/L5-1 != i ) WinCheckButton(hwndDlg, i, FALSE);
        else WinCheckButton(hwndDlg, i, TRUE);

      for ( i=TO_ARP_03; i<=TO_ARP_15; i++ )
        if ( TO_ARP_03+mArpWait/L3-1 != i ) WinCheckButton(hwndDlg, i, FALSE);
        else WinCheckButton(hwndDlg, i, TRUE);

      for ( i=TO_ARP_30; i<=TO_ARP_90; i++ )
        if ( TO_ARP_30+mArpWait/L15-2 != i ) WinCheckButton(hwndDlg, i, FALSE);
        else WinCheckButton(hwndDlg, i, TRUE);

      for ( i=TO_TCPB_10; i<=TO_TCPB_50; i++ )
        if ( TO_TCPB_10+mTcpWait/L10-1 != i ) WinCheckButton(hwndDlg,i,FALSE);
        else WinCheckButton(hwndDlg, i, TRUE);

      WinCheckButton(hwndDlg, C_LOG, mCommonLog);
      WinCheckButton(hwndDlg, S_LOG, !mCommonLog);

      WinCheckButton(hwndDlg, ARUN, mAutoRun);
      WinCheckButton(hwndDlg, USE_LOG, mAutoLog);
      WinCheckButton(hwndDlg, DNS, museDNS);
      WinCheckButton(hwndDlg, OTHD, museOTHD);
      WinCheckButton(hwndDlg, USE_HTML, mCrtHTMLfile);
      WinCheckButton(hwndDlg, USE_TEXT, mAutoSave);

      WinSendDlgItemMsg( hwndDlg, EF_HTML, EM_SETTEXTLIMIT,
                         (MPARAM)CCHMAXPATH, L0 );
      WinSendDlgItemMsg( hwndDlg, EF_TEXT, EM_SETTEXTLIMIT,
                         (MPARAM)CCHMAXPATH, L0 );
      WinSetDlgItemText(hwndDlg, EF_HTML, mHTMLpath);
      WinSetDlgItemText(hwndDlg, EF_TEXT, mszFullPath);
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_CONTROL
//-----------------------------------------------------------------------------
    case WM_CONTROL:
      {
      swt = SHORT1FROMMP(mp1);
      switch(SHORT1FROMMP(mp1))
        {
        case TO_PING_01:
        case TO_PING_02:
        case TO_PING_03:
        case TO_PING_04:
        case TO_PING_05:
        case TO_PING_06:
        case TO_PING_07:
        case TO_PING_08:
        case TO_PING_09:
        case TO_PING_10:
          {
          mtv_sec = swt-TO_PING_01+1;
          for ( i=TO_PING_01; i<=TO_PING_10; i++ )
            if ( TO_PING_01+mtv_sec-1 != i ) WinCheckButton(hwndDlg, i, FALSE);
            else WinCheckButton(hwndDlg, i, TRUE);
          return (0);
          }
        case TO_ARP_03:
        case TO_ARP_06:
        case TO_ARP_09:
        case TO_ARP_12:
        case TO_ARP_15:
          {
          mArpWait = (swt-TO_ARP_03+1)*L3;
          for ( i=TO_ARP_03; i<=TO_ARP_15; i++ )
            if (TO_ARP_03+mArpWait/L3-1 != i) WinCheckButton(hwndDlg,i,FALSE);
            else WinCheckButton(hwndDlg, i, TRUE);
          for (i=TO_ARP_30; i<=TO_ARP_90; i++) WinCheckButton(hwndDlg,i,FALSE);
          return (0);
          }
        case TO_ARP_30:
        case TO_ARP_45:
        case TO_ARP_60:
        case TO_ARP_75:
        case TO_ARP_90:
          {
          mArpWait = (swt-TO_ARP_30+2)*L15;
          for ( i=TO_ARP_30; i<=TO_ARP_90; i++ )
            if (TO_ARP_30+mArpWait/L15-2 != i) WinCheckButton(hwndDlg,i,FALSE);
            else WinCheckButton(hwndDlg, i, TRUE);
          for (i=TO_ARP_03; i<=TO_ARP_15; i++) WinCheckButton(hwndDlg,i,FALSE);
          return (0);
          }
        case TO_TCPB_10:
        case TO_TCPB_20:
        case TO_TCPB_30:
        case TO_TCPB_40:
        case TO_TCPB_50:
          {
          mTcpWait = (swt-TO_TCPB_10+1)*L10;
          for ( i=TO_TCPB_10; i<=TO_TCPB_50; i++ )
            if (TO_TCPB_10+mTcpWait/L10-1!=i) WinCheckButton(hwndDlg,i,FALSE);
            else WinCheckButton(hwndDlg, i, TRUE);
          return (0);
          }
        case ARUN_05:
        case ARUN_10:
        case ARUN_15:
        case ARUN_20:
        case ARUN_25:
        case ARUN_30:
        case ARUN_35:
        case ARUN_40:
        case ARUN_45:
        case ARUN_50:
        case ARUN_55:
        case ARUN_60:
          {
          mInterval = (swt-ARUN_05+1)*L5;
          for ( i=ARUN_05; i<=ARUN_60; i++ )
            if (ARUN_05+mInterval/L5-1 !=  i) WinCheckButton(hwndDlg,i,FALSE);
            else WinCheckButton(hwndDlg, i, TRUE);
          return (0);
          }
        case C_LOG:
        case S_LOG:
          {
          if ( swt == C_LOG ) mCommonLog = TRUE;
          else mCommonLog = FALSE;
          WinCheckButton(hwndDlg, C_LOG, mCommonLog);
          WinCheckButton(hwndDlg, S_LOG, !mCommonLog);
          return (0);
          }
        case USE_LOG:
          {
          mAutoLog = WinQueryButtonCheckstate(hwndDlg, USE_LOG);
          return (0);
          }
        case DNS:
          {
          museDNS = WinQueryButtonCheckstate(hwndDlg, DNS);
          return (0);
          }
        case OTHD:
          {
          museOTHD = WinQueryButtonCheckstate(hwndDlg, OTHD);
          return (0);
          }
        case ARUN:
          {
          mAutoRun = WinQueryButtonCheckstate(hwndDlg, ARUN);
          return (0);
          }
        case USE_HTML:
          {
          mCrtHTMLfile = WinQueryButtonCheckstate(hwndDlg, USE_HTML);
          return (0);
          }
        case USE_TEXT:
          {
          mAutoSave = WinQueryButtonCheckstate(hwndDlg, USE_TEXT);
          return (0);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case BRS_HTML:
          {
          GetFileName(HTMLtitle, mHTMLpath);
          WinSetDlgItemText(hwndDlg, EF_HTML, mHTMLpath);
          return(0);
          }
        case BRS_TEXT:
          {
          GetFileName(szTitle, mszFullPath);
          WinSetDlgItemText(hwndDlg, EF_TEXT, mszFullPath);
          return(0);
          }
        case DID_OK:
          {
          AutoRun = mAutoRun;
          AutoLog = mAutoLog;
          CommonLog = mCommonLog;
          Interval = mInterval;
          useDNS = museDNS;
          useOTHD = museOTHD;
          pingtv.tv_sec = mtv_sec;
          ArpWait = mArpWait;
          TcpWait = mTcpWait;
          CrtHTMLfile = mCrtHTMLfile;
          AutoSave = mAutoSave;
          strcpy(szFullPath, mszFullPath);
          strcpy(HTMLpath, mHTMLpath);

#ifdef CONFIG_LS
          SaveOpt(CFGname);
#endif
          break;
          }
        }
      }
      break;
    }
    return (WinDefDlgProc (hwndDlg,msg,mp1,mp2));
}
